/*============================================================================
  File:     TSQLvCLR.sql

  Summary:  This script code is used to test the code demos in
            the Transact-SQL or SQLCLR presentation by Bob Beauchemin

  Date:     Sept 15, 2005

  SQL Server Version: 9.00.1399.06
------------------------------------------------------------------------------
  Copyright (C) 2005 Bob Beauchemin, SQLskills, Inc.
  All rights reserved.

  This script is intended only as a supplement to demos and lectures
  given by Bob Beauchemin.  
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/


-- test the regex routine
select dbo.extractareacode(N'(503)-800-1212')

-- test the table-valued UDF
select * from dbo.initmethod('es-es')

-- must turn trustworthy on 
-- or catalog asymmetric key from assembly to master
-- for external access or unsafe
alter database pubs set trustworthy on

-- now test the external access assembly
exec getfile

-- compile-time type checking
-- can you do in TSQL?
CREATE FUNCTION add2sql(@x float, @y float)
RETURNS float
AS
BEGIN
RETURN @x + @y + rand(42)
END
GO

-- but in CLR...
-- Oh.
DROP TABLE simple
CREATE TABLE simple(
 x float,
 y float,
 z AS dbo.MyAdder(x,y) PERSISTED
)
GO

-- Oh.
DROP INDEX i1 on simple
CREATE INDEX i1 ON simple(z)
GO

-- test out the function that doesn't use SqlTypes
print dbo.UsingSQLtypes(1,1)
print dbo.UsingSQLtypes(3,null)

-- this one does
print dbo.UseSQLtypes(1,1)
print dbo.UseSQLtypes(3,null)

-- another choice, but only for UDF, not Sproc
DROP FUNCTION UseSQLtypes
DROP FUNCTION UsingSQLtypes
DROP FUNCTION MyAdder
DROP ASSEMBLY CLRProject

CREATE ASSEMBLY CLRProject FROM 'c:\temp\CLRProject.dll'
GO
CREATE FUNCTION UsingSQLTypes(@a int, @b int)
RETURNS int
WITH RETURNS NULL ON NULL INPUT
EXTERNAL NAME CLRProject.UserDefinedFunctions.UsingSQLTypes
GO